(defun c:CopyHatchRon (/ a b e h hp p x)
  ;; RJP » 2022-09-08
  (cond	((and (setq e (car (entsel "\nPick source hatch: ")))
	      (= "HATCH" (cdr (assoc 0 (entget e))))
	      (setq b (assoc 2 (entget e)))
	      (setq e (vlax-ename->vla-object e))
	      (setq a (mapcar '(lambda (x) (list x (vlax-get e x)))
			      '(associativehatch   backgroundcolor    elevation
				entitytransparency   gradientangle       gradientcentered
				gradientname          hatchobjecttype	  hatchstyle	      
				layer		   linetype	  linetypescale
				lineweight	   material	  origin
				patternangle	   patterndouble      patternscale
				patternspace	   plotstylename      truecolor
				visible                       isopenwidth
			       )
		      )
	      )
	 )
	 (setq hp (getvar 'hpname))
	 (setvar 'hpname (cdr b))
	 (while	(setq p (getpoint))
	   (setq h (entlast))
	   (command "_.bhatch" p "")
	   (cond ((not (equal h (setq h (entlast))))
		  (setq h (vlax-ename->vla-object h))
		  (foreach x a (vl-catch-all-apply 'vlax-put (list h (car x) (cadr x))))
		  ;; patternname (RO) cannot be set via vla for some reason ?
		  ;; (setq h (entget (vlax-vla-object->ename h)))
		  ;; (entmod (subst b (assoc 2 h) h))
		 )
	   )
	 )
	 (setvar 'hpname hp)
	)
  )
  (princ)
)